package cn.ezhizao.project.business.app.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * app管理对象 biz_app
 *
 * @author ezhizao
 * @date 2024-01-24
 */
@Data
@TableName(value = "biz_app")
public class BizApp extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 应用 id 唯一 */
    @ApiModelProperty(value = "${comment}")
    private String appId;

    /** 应用名称 */
    @Excel(name = "应用名称")
    @ApiModelProperty(value = "应用名称")
    private String name;

    /** 下载地址 */
    @Excel(name = "下载地址")
    @ApiModelProperty(value = "下载地址")
    private String url;

    /** 上传者 */
    @Excel(name = "上传者")
    @ApiModelProperty(value = "上传者")
    private String author;

    /** 类别 0 android / 1 ios */
    @Excel(name = "类别 0 android / 1 ios")
    @ApiModelProperty(value = "类别 0 android / 1 ios")
    private String type;

    /** 应用版本名称 1.0.0 */
    @Excel(name = "应用版本名称 1.0.0")
    @ApiModelProperty(value = "应用版本名称 1.0.0")
    private String versionName;

    /** 是否强制更新 */
    @Excel(name = "是否强制更新")
    @ApiModelProperty(value = "是否强制更新")
    private Integer isForceUpdate;

    /** 应用版本号 */
    @Excel(name = "应用版本号")
    @ApiModelProperty(value = "应用版本号")
    private String versionCode;

    /** 状态 */
    @Excel(name = "状态")
    @ApiModelProperty(value = "状态")
    private Integer status;

}
