package cn.ezhizao.project.business.carrierReject.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.carrierReject.domain.BizCarrierReject;
import cn.ezhizao.project.business.carrierReject.mapper.BizCarrierRejectMapper;
import cn.ezhizao.project.business.carrierReject.service.IBizCarrierRejectService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 企业租户Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-09
 */
@Service
public class BizCarrierRejectServiceImpl  extends ServiceImpl<BizCarrierRejectMapper, BizCarrierReject> implements IBizCarrierRejectService
{
    @Resource
    private BizCarrierRejectMapper bizCarrierRejectMapper;

    /**
     * 查询企业租户列表
     *
     * @param bizCarrierReject 企业租户
     * @return 企业租户
     */
    @Override
    public List<BizCarrierReject> getList(BizCarrierReject bizCarrierReject)
    {
        return bizCarrierRejectMapper.getList(bizCarrierReject);
    }

    /**
     * 物理删除
     * @param bizCarrierReject
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizCarrierReject bizCarrierReject){ return bizCarrierRejectMapper.physicalDelete(bizCarrierReject); };

}
