package cn.ezhizao.project.business.deptProcess.service.impl;

import cn.ezhizao.project.business.deptProcess.domain.BizDeptProcess;
import cn.ezhizao.project.business.deptProcess.mapper.BizDeptProcessMapper;
import cn.ezhizao.project.business.deptProcess.service.IBizDeptProcessService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;


/**
 * deptProcessService业务层处理
 *
 * @author ezhizao
 * @date 2023-12-11
 */
@Service
public class BizDeptProcessServiceImpl  extends ServiceImpl<BizDeptProcessMapper, BizDeptProcess> implements IBizDeptProcessService
{
    @Resource
    private BizDeptProcessMapper bizDeptProcessMapper;

    /**
     * 查询deptProcess列表
     *
     * @param bizDeptProcess deptProcess
     * @return deptProcess
     */
    @Override
    public List<BizDeptProcess> getList(BizDeptProcess bizDeptProcess)
    {
        return bizDeptProcessMapper.getList(bizDeptProcess);
    }

    /**
     * 物理删除
     * @param bizDeptProcess
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDeptProcess bizDeptProcess){ return bizDeptProcessMapper.physicalDelete(bizDeptProcess); }

    @Override
    public List<BizDeptProcess> getSpecialDeptProcessList() {
        return bizDeptProcessMapper.getSpecialDeptProcessList();
    }

}
