package cn.ezhizao.project.business.equipment.domain;

import java.util.Date;
import java.util.List;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;


/**
 * 设备青岛那对象 biz_equipment_detail
 *
 * @author ezhizao
 * @date 2023-11-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "biz_equipment_detail")
public class BizEquipmentDetail extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 设备档案id
     */
    @ApiModelProperty(value = "${comment}")
    private Long equipmentId;

    /**
     * 设备名称
     */
    @Excel(name = "设备名称")
    @ApiModelProperty(value = "设备名称")
    private String equipmentCode;

    /**
     * 使用部门 id
     */
    @ApiModelProperty(value = "使用部门ID")
    private Long usageDeptId;

    /**
     * 使用部门编码
     */
    @Excel(name = "使用部门编码")
    @ApiModelProperty(value = "使用部门编码")
    private String usageDeptCode;

    /**
     * 使用部门简称
     */
    @Excel(name = "使用部门简称")
    @ApiModelProperty(value = "使用部门简称")
    private String usageDeptAlias;

    /**
     * 报废日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
 @TableField(exist = false)
    private Date scrappingDate;

    /**
     * 设备状态id（对应数据字典id）
     */
    @ApiModelProperty(value = "报废日期")
    private Long equipmentStatusId;

    /**
     * 设备状态（NA：可用；WX：维修；CL：报废）
     */
    @Excel(name = "设备状态", readConverterExp = "N=A：可用；WX：维修；CL：报废")
    @ApiModelProperty(value = "设备状态")
    private String equipmentStatusCode;

    /**
     * 备注
     */
    @Excel(name = "备注", readConverterExp = "备注")
    @ApiModelProperty(value = "备注")
    private String remark;
    private Long isVirtualEquipment;

}
