package cn.ezhizao.project.business.equipment.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;


/**
 * 员工绑定设备组对象 biz_user_equipment_group
 *
 * @author ezhizao
 * @date 2024-01-15
 */
@Data
@TableName(value = "biz_user_equipment_group")
public class BizUserEquipmentGroup extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 员工姓名 */
    @Excel(name = "员工姓名")
    @ApiModelProperty(value = "员工姓名")
    private String nickName;

    /** 设备使用部门 */
    @ApiModelProperty(value = "员工姓名")
    private Long deptId;
    @TableField(exist = false)
    private List<BizUserEquipment> userEquipmentList;

}
