package cn.ezhizao.project.business.equipment.service;

import cn.ezhizao.project.business.equipment.domain.BizEquipmentCategory;
import cn.ezhizao.project.business.equipment.domain.CategoryOptions;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * 设备档案Service接口
 *
 * @author ezhizao
 * @date 2023-11-14
 */
public interface IBizEquipmentCategoryService extends IService<BizEquipmentCategory> {

    /**
     * 物理删除
     *
     * @param id 要删除的数据id
     * @return 删除结果
     */
    int physicalDelete(Long id);

    /**
     * 返回类别的选项
     * @param list 类别列表
     * @return 选项集合
     */
    List<CategoryOptions> getCategoryOptions(List<BizEquipmentCategory> list);

    /**
     * 获取子类别
     * @param list 类别列表
     */
    void getChildren(List<BizEquipmentCategory> list);
}
