package cn.ezhizao.project.business.equipment.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.equipment.domain.BizUserEquipmentGroup;
import cn.ezhizao.project.business.equipment.mapper.BizUserEquipmentGroupMapper;
import cn.ezhizao.project.business.equipment.service.IBizUserEquipmentGroupService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;




/**
 * 员工绑定设备组Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-15
 */
@Service
public class BizUserEquipmentGroupServiceImpl  extends ServiceImpl<BizUserEquipmentGroupMapper, BizUserEquipmentGroup> implements IBizUserEquipmentGroupService
{
    @Resource
    private BizUserEquipmentGroupMapper bizUserEquipmentGroupMapper;

    /**
     * 查询员工绑定设备组列表
     *
     * @param bizUserEquipmentGroup 员工绑定设备组
     * @return 员工绑定设备组
     */
    @Override
    public List<BizUserEquipmentGroup> getList(BizUserEquipmentGroup bizUserEquipmentGroup)
    {
        return bizUserEquipmentGroupMapper.getList(bizUserEquipmentGroup);
    }

    /**
     * 物理删除
     * @param bizUserEquipmentGroup
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizUserEquipmentGroup bizUserEquipmentGroup){ return bizUserEquipmentGroupMapper.physicalDelete(bizUserEquipmentGroup); };

}
