package cn.ezhizao.project.business.inspection.domain;

import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 企业租户对象 biz_carrier_category
 *
 * @author ezhizao
 * @date   2024-03-18
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "biz_product_inspection_instruction")
public class BizProductInspectionInstruction extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "租户id")
    private Long tenantId;

    @ApiModelProperty(value = "1：分选标准；2：检查指导书；")
    private Integer type;

    @ApiModelProperty(value = "产品工艺外键id")
    private Long technologicalProcessId;

    @ApiModelProperty(value = "产品id")
    private Long productId;

    @ApiModelProperty(value = "工艺版本A,B,C")
    private String technologyVersion;

    @ApiModelProperty(value = "产品工艺外键id")
    private Long technologicalProcessDetailId;

    @ApiModelProperty(value = "工序id")
    private Long processId;

    @ApiModelProperty(value = "检查标准外键id")
    private Long inspectionInstructionId;

    @ApiModelProperty(value = "检查标准")
    private String standard;

    @ApiModelProperty(value = "检查仪器设备（用于检查指导书）")
    private String equipment;

    @ApiModelProperty(value = "排序")
    private Integer sort;

}
