package cn.ezhizao.project.business.inspection.mapper;

import cn.ezhizao.project.business.inspection.domain.BizInspectionInstruction;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;
import java.util.Map;

/**
 * 检查指导书Mapper接口
 *
 * @author zhuangdezheng
 * @date   2024-04-22
 */
public interface BizInspectionInstructionMapper extends BaseMapper<BizInspectionInstruction> {

    /**
     * 查询企业租户列表
     *
     * @param data 企业租户
     * @return 企业租户集合
     */
    public List<BizInspectionInstruction> getList(Map<String, Object> data);

    /**
     * 物理删除
     *
     * @param bizInspectionInstruction 载具信息
     * @return 删除结果
     */
    public int physicalDelete(BizInspectionInstruction bizInspectionInstruction);
}
