package cn.ezhizao.project.business.outsource.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.outsource.mapper.BizOutsourcedOrderMapper;
import cn.ezhizao.project.business.outsource.domain.BizOutsourcedOrder;
import cn.ezhizao.project.business.outsource.service.IBizOutsourcedOrderService;

/**
 * 外协单主
带箱方式，是整单的。如果换新箱子，明细中，都需要更换箱子Service业务层处理
 *
 * @author ezhizao
 * @date 2024-05-28
 */
@Service
public class BizOutsourcedOrderServiceImpl  extends ServiceImpl<BizOutsourcedOrderMapper, BizOutsourcedOrder> implements IBizOutsourcedOrderService
{
    @Resource
    private BizOutsourcedOrderMapper bizOutsourcedOrderMapper;

    /**
     * 查询外协单主
带箱方式，是整单的。如果换新箱子，明细中，都需要更换箱子列表
     *
     * @param bizOutsourcedOrder 外协单主
带箱方式，是整单的。如果换新箱子，明细中，都需要更换箱子
     * @return 外协单主
带箱方式，是整单的。如果换新箱子，明细中，都需要更换箱子
     */
    @Override
    public List<BizOutsourcedOrder> getList(BizOutsourcedOrder bizOutsourcedOrder)
    {
        return bizOutsourcedOrderMapper.getList(bizOutsourcedOrder);
    }

    /**
     * 物理删除
     * @param bizOutsourcedOrder
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizOutsourcedOrder bizOutsourcedOrder){ return bizOutsourcedOrderMapper.physicalDelete(bizOutsourcedOrder); };

}
