package cn.ezhizao.project.business.product.controller;

import cn.ezhizao.common.utils.SecurityUtils;
import cn.ezhizao.common.utils.poi.ExcelUtil;
import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.framework.web.page.TableDataInfo;
import cn.ezhizao.project.business.deptProcess.domain.BizDeptProcess;
import cn.ezhizao.project.business.deptProcess.service.IBizDeptProcessService;
import cn.ezhizao.project.business.process.domain.BizProcess;
import cn.ezhizao.project.business.process.service.IBizProcessService;
import cn.ezhizao.project.business.product.domain.*;
import cn.ezhizao.project.business.product.service.*;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroup;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupDetail;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupSubPlan;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupDetailService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupSubPlanService;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import cn.ezhizao.project.business.turnover.domain.BizTurnover;
import cn.ezhizao.project.business.turnover.service.IBizTurnoverService;
import cn.ezhizao.project.system.domain.SysDept;
import cn.ezhizao.project.system.domain.SysDeptUser;
import cn.ezhizao.project.system.domain.SysUser;
import cn.ezhizao.project.system.mapper.SysDeptMapper;
import cn.ezhizao.project.system.mapper.SysUserMapper;
import cn.ezhizao.project.system.service.ISysDeptUserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 报工记录Controller
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@RestController
@RequestMapping("/business/dayworkItem")
public class BizDayworkItemController extends BaseController {
    @Resource
    private IBizDayworkItemService bizDayworkItemService;

    @Resource
    private IBizDayworkService bizDayworkService;
    @Resource
    HttpServletRequest request;

    @Resource
    private IBizDayworkCarrierService bizDayworkCarrierService;

    @Resource
    private IBizDayworkItemRejectService bizDayworkItemRejectService;

    @Resource
    private IBizProcessService processService;

    @Resource
    private IBizProductionResourceGroupDetailService bizProductionResourceGroupDetailService;
    @Resource
    private IBizProductionResourceGroupService bizProductionResourceGroupService;

    @Resource
    private ISysDeptUserService sysDeptUserService;

    @Resource
    private SysUserMapper sysUserMapper;

    @Resource
    private IBizTurnoverService bizTurnoverService;

    @Resource
    private  IBizLotService bizLotService;


    @Resource
    private SysDeptMapper sysDeptMapper;

    @Resource
    private IBizProductionPlanDetailService bizProductionPlanDetailService;

    @Resource
    private IBizProductionResourceGroupSubPlanService bizProductionResourceGroupSubPlanService;
    @Resource
    private IBizLotTechnologicalProcessService bizLotTechnologicalProcessService;
    @Resource
    private IBizLotTechnologicalProcessDetailService bizLotTechnologicalProcessDetailService;
    @Resource
    private IBizTechnologicalProcessDetailService bizTechnologicalProcessDetailService;

    @Resource
    private IBizDeptProcessService bizDeptProcessService;
    /**
     * 查询报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:list')")
    @GetMapping("/list")
    public TableDataInfo list(BizDayworkItem bizDayworkItem) {
//        SysUser user = SecurityUtils.getLoginUser().getUser();
////        startPage();
//        bizDayworkItem.setUserId(user.getUserId());
//        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
//        //人员只能看到最近的一条报工记录中工序的报工
//        List<BizDayworkItem> itemList = new ArrayList<>();
//        Long processId = 0L;
//        if (list.size() > 0) {
//            processId = list.get(0).getProcessId();
//        }
//        /** 根据当前工序查询下一道工序 */
//        for (BizDayworkItem item : list) {
//            for (int i = 0; i < item.getProcessSequence().size(); i++) {
//                if ((i + 1) < item.getProcessSequence().size()) {
//                    if (item.getProcessId().equals(item.getProcessSequence().get(i).getId())) {
//
//                        item.setNextProcess(item.getProcessSequence().get(i + 1));
//                        //查询出非本工段的第一道序
//                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
//                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
//                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
//                                break;
//                            }
//                        }
//                    }
//                }
//            }
//            // 设置上一工段,周转用
//            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("process_id", item.getProcessId()).list();
//            for (int i = 0; i < dayworkItemList.size(); i++) {
//                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
//                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
//                    break;
//                }
//            }
//            //只保留当前工序的报工记录
//            if (processId.equals(item.getProcessId())) {
//                itemList.add(item);
//            }
//        }
//
//        return getDataTable(itemList);
        //0420
        SysUser user = SecurityUtils.getLoginUser().getUser();
//        startPage();
        bizDayworkItem.setUserId(user.getUserId());
        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        //如果是废品回用，ProcessSequence从新表拿
        if(bizDayworkItem.getIsAmend() ==1  ||bizDayworkItem.getIsWasteRecycling() ==1 ) {
            BizLotTechnologicalProcess technologicalProcess = bizLotTechnologicalProcessService.query().eq("lot_id",bizDayworkItem.getLotId()).eq("is_stop",0).one();
            List<BizLotTechnologicalProcessDetail> bizTechnologicalWasteRecyclingDetails = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id",technologicalProcess.getId()).orderByAsc("process_step_number").list();
           //查询所有工段下的工序
            List<BizDeptProcess> deptProcessList = bizDeptProcessService.query().list();
            List<BizProcess> processList = new ArrayList<>();
            for(BizLotTechnologicalProcessDetail bizTechnologicalWasteRecyclingDetail : bizTechnologicalWasteRecyclingDetails) {
                BizProcess process = new BizProcess();
                process.setId(bizTechnologicalWasteRecyclingDetail.getProcessId());
                process.setProcessCode(bizTechnologicalWasteRecyclingDetail.getProcessCode());
                process.setProcessStepNumber(bizTechnologicalWasteRecyclingDetail.getProcessStepNumber());
                process.setProcessAlias(bizTechnologicalWasteRecyclingDetail.getProcessAlias());
                process.setTechnologicalProcessDetailId(bizTechnologicalWasteRecyclingDetail.getId());
                process.setDeptProcess(deptProcessList.stream().filter(deptProcess -> deptProcess.getProcessId().equals(bizTechnologicalWasteRecyclingDetail.getProcessId())).collect(Collectors.toList()));
                processList.add(process);
            }
            list.stream().forEach(item -> {item.setProcessSequence(processList);});
            if(bizDayworkItem.getProcessStepNumber() != null) {
                list.forEach(item -> {
                    item.setProcess(
                            item.getProcessSequence().stream()
                                    .filter(process -> process.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()))
                                    .findFirst()
                                    .orElse(null) // 如果未找到匹配的 process，则设置为 null
                    );
                });
            }
        }
        //人员只能看到最近的一条报工记录中工序的报工
        List<BizDayworkItem> itemList = new ArrayList<>();
        String processStepNumber = "";
        if (list.size() > 0) {
            processStepNumber = list.get(0).getProcessStepNumber();
        }
        /** 根据当前工序查询下一道工序 */
        for (BizDayworkItem item : list) {
            for (int i = 0; i < item.getProcessSequence().size(); i++) {
                if ((i + 1) < item.getProcessSequence().size()) {
                    if (item.getProcessStepNumber().equals(item.getProcessSequence().get(i).getProcessStepNumber())) {

                        item.setNextProcess(item.getProcessSequence().get(i + 1));
                        //查询出非本工段的第一道序
                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
                                break;
                            }
                        }
                    }
                }
            }
            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id",item.getLotId()).eq("process_step_number", item.getProcessStepNumber()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
            //只保留当前工序的报工记录
            if (processStepNumber.equals(item.getProcessStepNumber())) {
                itemList.add(item);
            }
        }

        return getDataTable(itemList);
    }



    /**
     * 查询当前是否为首序
     */
    @Log(title = "是否为首序拆线呢", businessType = BusinessType.SELECT)
    @GetMapping(value = "/getIsFirstOrder/{dayWorkId}")
    public AjaxResult getIsFirstOrder(@PathVariable("dayWorkId") Long dayWorkId) {
        HashMap<String, Object> map = new HashMap<>();
        //根据dayWorkId查询出当前工序的报工记录(按照工序筛选每道工序只查询一条数据)
        List<BizDayworkItem> list = bizDayworkItemService.getItemScreen(dayWorkId);
        //查询出来的数据等于1条则为首序
        if(list.size() == 1){
            map.put("isFirstOrder",true);
        }else{
            map.put("isFirstOrder",false);
        }
        return success(map);
    }

    @GetMapping("/listItem")
    public TableDataInfo listItem(BizDayworkItem bizDayworkItem) {
        QueryWrapper<BizDayworkItem> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("status", bizDayworkItem.getStatus()).eq("daywork_id", bizDayworkItem.getDayworkId());
        List<BizDayworkItem> list = bizDayworkItemService.list(queryWrapper);

        list.forEach(item -> {
            QueryWrapper<BizDayworkItemReject> wrapper = new QueryWrapper<>();
            wrapper.eq("daywork_item_id", item.getId());
            List<BizDayworkItemReject> rejectList = bizDayworkItemRejectService.list(wrapper);
            int sum = 0;
            for (int i = 0; i < rejectList.size(); i++) {
                sum += rejectList.get(i).getRejectNum();
            }
            item.setRejectSum(sum);
        });
        return getDataTable(list);
    }

    @GetMapping("/getDayWorkItemHistory")
    public TableDataInfo getDayWorkItemHistory(String startTime, String endTime) {
        startTime = startTime + " 00:00:00";
        endTime = endTime + " 23:59:59";

        List<BizDayworkItem> list = bizDayworkItemService.getDayWorkItemHistory(startTime, endTime, SecurityUtils.getLoginUser().getUser().getUserName());
        return getDataTable(list);
    }

    /**
     * 查询报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:list')")
    @GetMapping("/tonoverList")
    public TableDataInfo tonoverList(BizDayworkItem bizDayworkItem) {

        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        //人员只能看到最近的一条报工记录中工序的报工
        List<BizDayworkItem> itemList = new ArrayList<>();
        Long processId = 0L;
        if (list.size() > 0) {
            processId = list.get(0).getProcessId();
        }
        /** 根据当前工序查询下一道工序 */
        for (BizDayworkItem item : list) {
            for (int i = 0; i < item.getProcessSequence().size(); i++) {
                if ((i + 1) < item.getProcessSequence().size()) {
                    if (item.getProcessId().equals(item.getProcessSequence().get(i).getId())) {

                        item.setNextProcess(item.getProcessSequence().get(i + 1));
                        //查询出非本工段的第一道序
                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
                                break;
                            }
                        }
                    }
                }
            }
            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().eq("lot_id", item.getLotId()).eq("process_id", item.getProcessId()).lt("create_time", item.getCreateTime()).orderByDesc("create_time").last("limit 1").list();
            // List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", item.getLotId()).eq("process_id", item.getProcessId()).list();

            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
            //只保留当前工序的报工记录
//            if (processId.equals(item.getProcessId())){
            itemList.add(item);
        }
//        }

        return getDataTable(itemList);
    }

    /**
     * 导出报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:export')")
    @Log(title = "报工记录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        ExcelUtil<BizDayworkItem> util = new ExcelUtil<BizDayworkItem>(BizDayworkItem.class);
        util.exportExcel(response, list, "报工记录数据");
    }

    /**
     * 获取报工记录详细信息
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(bizDayworkItemService.getById(id));
    }

    /**
     * 查询当前批次完成状态
     */
    @GetMapping(value = "/startStatus")
    public AjaxResult startStatus(BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> list = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_id", bizDayworkItem.getProcessId()).eq("status", 3).list();
        if (list.size() > 0) {

            return success(true);

        }

        return success(false);
    }

    /**
     * 根据载具获得待周转信息，
     * 用于周转时，显示 从哪个工段，到哪个工段
     */
    @GetMapping(value = "/getDayworkItemByCarrier")
    public AjaxResult getDayworkItemByCarrier(BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> dayworkItemByCarriers = bizDayworkItemService.getDayworkItemByCarrier(bizDayworkItem);

        for (BizDayworkItem dayworkItemByCarrier : dayworkItemByCarriers) {
            BizProcess byId = processService.getById(dayworkItemByCarrier.getProcessId());
            dayworkItemByCarrier.setNextProcess(byId);

            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", dayworkItemByCarrier.getLotId()).eq("process_id", dayworkItemByCarrier.getProcessId()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    dayworkItemByCarrier.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
        }
        return success(dayworkItemByCarriers);
    }

    /**
     * 新增报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping
    public AjaxResult add(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        // 设置工时

        /** 如果是已完成工序，生成一条空报工记录保存下一道工序 */
        BizDaywork daywork = new BizDaywork();
        daywork.setId(bizDayworkItem.getDayworkId());

        List<BizDaywork> list = bizDayworkService.getList(daywork);
        daywork = list.get(0);

        //如果是修改工单，则获取该工单工序
        if(daywork.getIsAmend()==1 || daywork.getIsWasteRecycling()==1){
            List<BizProcess> processList=new ArrayList<>();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", daywork.getTechnologicalProcessId()).list();
            bizLotTechnologicalProcessDetail.forEach(item->{
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        }else {
            List<BizProcess> processList=new ArrayList<>();
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetail = bizTechnologicalProcessDetailService.query().eq("technological_process_id", daywork.getTechnologicalProcessId()).ne("tenant_id",9).list();
            bizTechnologicalProcessDetail.forEach(item->{
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        }

        if(daywork.getIsAmend()==1){
            bizDayworkItem.setFormDayworkItemId(1L);
        }
        //并且计算该报工批次的当前工序下的合格数总量
        BizDayworkItem bizItem = new BizDayworkItem();
        bizItem.setDayworkId(bizDayworkItem.getDayworkId());
        bizItem.setProcessId(bizDayworkItem.getProcessId());
        bizItem.setTechnologicalProcessDetailId(bizDayworkItem.getTechnologicalProcessDetailId());
        List<BizDayworkItem> itemList = bizDayworkItemService.getList(bizItem);
        //获取当前工序下的总合格数
        Integer lot = 0;
        //如果非手续
        if (bizDayworkItem.getQualifiedNum() != null) {
            lot = bizDayworkItem.getQualifiedNum();
        }
        for (BizDayworkItem dayworkItem : itemList) {
            lot += dayworkItem.getQualifiedNum();
        }
        // 结束报工校验
        //如果是手续(上一道序的合格数是0)校验报工批次的单批数
        if ((bizDayworkItem.getStatus().equals("2") || bizDayworkItem.getStatus().equals("3")) && !bizDayworkItem.getIsPreProcess()) {
            if (daywork.getProcessQualifiedNum() == 0) {
                if (lot > (daywork.getOneLotQuantity() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            } else {
                if (lot > (daywork.getProcessQualifiedNum() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            }
        }

        // 已送达状态更改daywork的当前部门
        if (bizDayworkItem.getStatus().equals("7")) {
            daywork.setDeptId(bizDayworkItem.getDeptId());
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            bizDayworkService.updateById(daywork);
        }

        if (bizDayworkItem.getStatus().equals("5")) {
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            bizDayworkService.updateById(daywork);
        }
        /** 当最后一道序完成时，释放该批次下所有载具 */
        if (bizDayworkItem.getStatus().equals("3")) {
            //校验当前序是否还有未完成的报工
            List<BizDayworkItem> items = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_id", bizDayworkItem.getProcessId()).lt("status", 2).ne("id", bizDayworkItem.getId()).list();
            if (items.size() > 0) {
                return error("当前工序还有其他未完成的报工，不允许工序完成");
            }
            //工序结束时将合格数保存
            daywork.setProtemProcessId(bizDayworkItem.getProcessId());
            daywork.setTemporaryProcessQualifiedNum(lot);
            // 此处在biz_daywork_qualified中间表中，插入一条数据
            // 记录当前批次，当前工序的投入数、合格数
            bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
            bizDayworkService.updateById(daywork);

            //判断当前序为最后一道序
            if (bizDayworkItem.getProcessStepNumber().equals(daywork.getProcessSequence().get(daywork.getProcessSequence().size() - 1).getProcessStepNumber())) {
                bizDayworkCarrierService.removeByDayworkId(daywork.getId());
            }
        }
        //如果没有合格数，则投产数量为总数量，上道序的合格数为下到序的投产数
        if (daywork.getProcessQualifiedNum() == 0) {
            bizDayworkItem.setProdNum(daywork.getProductionQuantity());
        } else {
            bizDayworkItem.setProdNum(daywork.getProcessQualifiedNum());
        }
        // 现在等于4的时候就要能扫码开始批次,所以要设置一下部门pc查询计划单分配活
//        if(bizDayworkItem.getStatus().equals("4")){
//            daywork.setDeptId(bizDayworkItem.getDeptId());
//            bizDayworkService.updateById(daywork);
//        }
        bizDayworkItem.setLotId(daywork.getLotId());
        bizDayworkItem.setLotCode(daywork.getLotCode());
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDayworkItem.setUserId(user.getUserId());
        bizDayworkItem.setUserName(user.getUserName());
        bizDayworkItem.setNickName(user.getNickName());
        String[] statusArr = {"0", "4", "5", "7"};
        if (Arrays.asList(statusArr).contains(bizDayworkItem.getStatus())) {
            bizDayworkItem.setWorkingHours(0L);
        } else {
            bizDayworkItem.setWorkingHours(bizDayworkItem.getEndTime().getTime() - bizDayworkItem.getStartTime().getTime());
        }
        boolean batch = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        //先保存item再保存废品原因
        if ("2".equals(bizDayworkItem.getStatus()) || "3".equals(bizDayworkItem.getStatus())) {
            for (BizDayworkItemReject item : bizDayworkItem.getRejectList()) {
                item.setDayworkItemId(bizDayworkItem.getId());
                item.setDayworkId(bizDayworkItem.getDayworkId());
                item.setLotId(bizDayworkItem.getLotId());
            }
        }
        // 自动派活
        SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (sysDept.getAutoAllocation() == 1) {
            // 查资源组
            List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()));

            //查询是否已经分配资源组
            BizProductionResourceGroupSubPlan groupSubPlan=new BizProductionResourceGroupSubPlan();
            groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
            groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
            List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getList(groupSubPlan);
            //如果没分配
            if(groupSubPlanList.size()==0){
                //查产品id
                BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                //存放保存的subPlanList
                List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                for (BizProductionResourceGroup info : productionResourceGroupList) {
                    BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                    subPlan.setProductId(productionPlanDetail.getProductId());
                    subPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
                    subPlan.setTechnologicalProcessId(bizDayworkItem.getTechnologicalProcessId());
                    subPlan.setResourceGroupId(info.getId());
                    subPlan.setDeptId(bizDayworkItem.getDeptId());
                    subPlan.setResourceGroupCode(info.getCode());
                    subPlanList.add(subPlan);
                }
                bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
            }

        }
        bizDayworkItemRejectService.saveBatch(bizDayworkItem.getRejectList());
        return toAjax(batch);

    }

    /**
     * 批量修改报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PutMapping("/updateBatch")
    public AjaxResult updateBatch(@RequestBody List<BizDayworkItem> bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        List<Long> ids = new ArrayList<>();
        for (BizDayworkItem item : bizDayworkItem) {
            if (item.getStatus().equals("5")) {
                BizDaywork daywork = new BizDaywork();
                daywork.setId(item.getDayworkId());
                daywork = bizDayworkService.getList(daywork).get(0);
                daywork.setDeptId(item.getDeptId());
                //daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
                // 此处在biz_daywork_qualified中间表中，插入一条数据
                // 记录当前批次，当前工序的投入数、合格数

                bizDayworkService.updateById(daywork);
                item.setRecipientId(user.getUserId());
                ids.add(item.getId());
            } else if (item.getStatus().equals("7")) {
                BizDaywork daywork = new BizDaywork();
                daywork.setId(item.getDayworkId());
                daywork = bizDayworkService.getList(daywork).get(0);
                daywork.setDeptId(item.getDeptId());
                //daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
                // 此处在biz_daywork_qualified中间表中，插入一条数据
                // 记录当前批次，当前工序的投入数、合格数

                bizDayworkService.updateById(daywork);
                item.setRecipientId(user.getUserId());
                ids.add(item.getId());
                BizTurnover turnover = bizTurnoverService.getOne(new QueryWrapper<BizTurnover>().eq("dept_id", item.getDeptId()).eq("status", 9));
                item.setPlaceId(turnover.getId());
                item.setPlace(turnover.getCode());
            } else {
                item.setUserId(user.getUserId());
                item.setUserName(user.getUserName());
                item.setNickName(user.getNickName());
                ids.add(item.getId());
            }
        }
        List<BizDayworkItem> oldList = bizDayworkItemService.query().in("id", ids).list();

        return toAjax(saveOrUpdateBatch(bizDayworkItemService, bizDayworkItem, oldList));
    }


    @PutMapping("/updateBatchBack")
    public AjaxResult updateBatchBack(@RequestBody List<BizDayworkItem> bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        List list = new ArrayList<>();
        for (int i = 0; i < bizDayworkItem.size(); i++) {
            list.add(bizDayworkItem.get(i));
            SysUser user = sysUserMapper.selectUserById(bizDayworkItem.get(i).getCreatorId());
            bizDayworkItem.get(i).setNickName(user.getNickName());
        }
        return toAjax(saveOrUpdateBatch(bizDayworkItemService, bizDayworkItem, list));
    }

    /**
     * 批量新增报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/saveBatch")
    public AjaxResult saveBatch(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //        String tenantId = request.getHeader("tenantId");
        BizDaywork daywork = bizDayworkService.getById(bizDayworkItem.getDayworkId());
        if(daywork.getIsAmend()==1){
            bizDayworkItem.setFormDayworkItemId(1l);
        }
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDayworkItem.setUserId(user.getUserId());
        bizDayworkItem.setUserName(user.getUserName());
        bizDayworkItem.setNickName(user.getNickName());
//          bizDayworkItem.setTenantId(Long.valueOf(tenantId));
        boolean b = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        if (bizDayworkItem.getCollaborationList().size() > 0) {
            for (BizDayworkItemCollaboration collaboration : bizDayworkItem.getCollaborationList()) {
                collaboration.setDayworkId(bizDayworkItem.getDayworkId());
                collaboration.setDayworkItemId(bizDayworkItem.getId());
                collaboration.insert();
            }
        }
        // 判断开始报工的批次在不在滚筒,如果在开始报工后制动鼓解绑载具
        SysDept dept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (dept.getAutoUnbind() == 1) {
            List<BizDayworkCarrier> oldList = bizDayworkCarrierService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("is_changed", 0).list();
            List<BizDayworkCarrier> newList = oldList.stream().collect(Collectors.toList());
            newList.forEach(item -> item.setIsChanged(1));
            saveOrUpdateCarrierBatch(bizDayworkCarrierService, newList, oldList);
        }
        return toAjax(b);
    }

    /**
     * 临时报工
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/proTem")
    public AjaxResult proTem(@RequestBody List<BizProductionResourceGroupDetail> details) {
        //查询出当前批次
        BizDaywork queryDaywork = new BizDaywork();
        queryDaywork.setId(details.get(0).getProtemDayworkId());

        SysUser user = SecurityUtils.getLoginUser().getUser();
        Long currentUserId = user.getUserId();

        BizDaywork daywork = bizDayworkService.getList(queryDaywork).get(0);
        List<BizDayworkItem>  allDayworkItems=new ArrayList<>();
        BizDayworkItem latest=null;
         if(daywork!=null){
             allDayworkItems = bizDayworkItemService.query().eq("daywork_id",daywork.getId()).list();
             // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
             List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                     .filter(di -> di.getDayworkId().equals(daywork.getId()) && di.getUserId().equals(currentUserId))
                     .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                     .collect(Collectors.toList());

             // 获取最后一条报工明细
             latest = currentDayworkItems.get(0);
         }

        //如果没找到自己的报工数据最后一条，提示
        if(latest==null){
            return error("未匹配到最后一条报工信息");
        }

        //协作者是否在部门人员里，如果没有，添加
        QueryWrapper<SysDeptUser> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("dept_id", details.get(0).getDeptId());
        queryWrapper.eq("deleted", 0);
        queryWrapper.eq("is_temporary", 0);
        List<SysDeptUser> deptUserList = sysDeptUserService.list(queryWrapper);
        List<Long> ids = new ArrayList<>();
        List<Long> userIds = new ArrayList<>();
        for (SysDeptUser deptUser : deptUserList) {
            ids.add(deptUser.getUserId());
        }
        for (BizProductionResourceGroupDetail detail : details) {
            userIds.add(detail.getCommonId());
        }
        List<SysDeptUser> detail = new ArrayList<>();
        for (Long userId : userIds) {
            if (!ids.contains(userId)) {
                SysDeptUser deptUser = new SysDeptUser();
                deptUser.setTenantId(details.get(0).getTenantId());
                deptUser.setDeptId(details.get(0).getDeptId());
                deptUser.setUserId(userId);
                deptUser.setIsTemporary(details.get(0).getProtemDayworkId());
                detail.add(deptUser);
            }
        }
        sysDeptUserService.saveBatch(detail);
        //该协作者添加到该工段的资源组明细
//        QueryWrapper<BizProductionResourceGroupDetail> wrapper = new QueryWrapper<>();
//        wrapper.eq("dept_id",details.get(0).getDeptId());
//        wrapper.eq("production_resource_group_id",details.get(0).getProductionResourceGroupId());
//        wrapper.eq("deleted",0);
//        wrapper.eq("common_type","person");
//        List<BizProductionResourceGroupDetail> productionResourceGroupDetailList = bizProductionResourceGroupDetailService.list(wrapper);
//        List<Long> productionResourceGroupDetailIds = new ArrayList<>();
//        for (BizProductionResourceGroupDetail productionResourceGroupDetail : productionResourceGroupDetailList) {
//            productionResourceGroupDetailIds.add(productionResourceGroupDetail.getCommonId());
//        }
//        List<BizProductionResourceGroupDetail> newList = new ArrayList<>();

        // 0223 不选择资源组，将邀请人的当前工段所有的资源组都分配给被邀请人
        List<BizProductionResourceGroup> groupList = bizProductionResourceGroupService.query().eq("dept_id", details.get(0).getDeptId()).list();
        List<Long> groupIds = new ArrayList<>();
        for (BizProductionResourceGroup group : groupList) {
            groupIds.add(group.getId());
        }
        //查询出当前用户在该工段的所有资源组
        List<BizProductionResourceGroupDetail> list = bizProductionResourceGroupDetailService.query().eq("common_id", SecurityUtils.getLoginUser().getUser().getUserId()).in("production_resource_group_id", groupIds).list();
        List<Long> groups = new ArrayList<>();
        for (BizProductionResourceGroupDetail item : list) {
            groups.add(item.getProductionResourceGroupId());
        }
        List<BizDayworkItem> newItemList = new ArrayList<>();
        List<BizProductionResourceGroupDetail> newDetails = new ArrayList<>();
        //遍历的邀请者的差集是否大于0
        Boolean flag = false;
        for (BizProductionResourceGroupDetail item : details) {
            //查询被邀请人在该工段所有的资源组
            List<BizProductionResourceGroupDetail> inviteList = bizProductionResourceGroupDetailService.query().eq("common_id", item.getCommonId()).in("production_resource_group_id", groupIds).list();
            List<Long> inviteGroups = new ArrayList<>();
            for (BizProductionResourceGroupDetail inviteItem : inviteList) {
                inviteGroups.add(inviteItem.getProductionResourceGroupId());
            }
            //存放当前用户和被邀请人员资源组的差集
            List<Long> filterGroupIds = new ArrayList<>();
            for (Long group : groups) {
                if (!inviteGroups.contains(group)) {
                    filterGroupIds.add(group);
                }
            }
            //把被邀请人加进每个资源组
            if (filterGroupIds.size() > 0) {
                flag = true;
                for (Long id : filterGroupIds) {
                    BizProductionResourceGroupDetail newDetail = new BizProductionResourceGroupDetail();
                    newDetail.setCommonId(item.getCommonId());
                    newDetail.setCommonName(item.getCommonName());
                    newDetail.setCommonCode(item.getCommonCode());
                    newDetail.setCommonType(item.getCommonType());
                    newDetail.setProtemDayworkId(item.getProtemDayworkId());
                    newDetail.setProtemProcessId(item.getProtemProcessId());
                    newDetail.setDeptId(item.getDeptId());
                    // 设置 productionResourceGroupId 属性为当前的 id
                    newDetail.setProductionResourceGroupId(id);
                    newDetails.add(newDetail);
                }

                //保存一条未开始的报工


            }
            /** 添加一条报工批次时生成一条未开始的Item */
            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(daywork.getId());
            bizDayworkItem.setLotId(daywork.getLotId());
            bizDayworkItem.setUserId(item.getCommonId());
            bizDayworkItem.setUserName(item.getCommonCode());
            bizDayworkItem.setNickName(item.getCommonName());
            bizDayworkItem.setProcessStepNumber(latest.getProcessStepNumber());
            bizDayworkItem.setProdNum(latest.getProdNum());
            bizDayworkItem.setTechnologicalProcessId(latest.getTechnologicalProcessId());
            bizDayworkItem.setProductionPlanDetailId(latest.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessDetailId(item.getTechnologicalProcessDetailId());
            //0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(daywork.getCurrentProcess().getId());
            bizDayworkItem.setDeptName(latest.getDeptName());
            bizDayworkItem.setDeptId(details.get(0).getDeptId());
            newItemList.add(bizDayworkItem);
        }
        //}
        if (flag) {
            bizDayworkItemService.saveBatch(newItemList);
            boolean batch = bizProductionResourceGroupDetailService.saveBatch(newDetails);

            return toAjax(batch);
        } else {
            return success(bizDayworkItemService.saveBatch(newItemList));
        }
    }

    //    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @PostMapping("/replacing")
    public AjaxResult replacing(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        return toAjax(bizDayworkItemService.save(bizDayworkItem));
    }

    /**
     * 修改报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:edit')")
    @Log(title = "报工记录", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
//        String tenantId = request.getHeader("tenantId");
//        bizDayworkItem.setTenantId(Long.valueOf(tenantId));
        return toAjax(bizDayworkItemService.updateById(bizDayworkItem));
    }

    /**
     * 删除报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:remove')")
    @Log(title = "报工记录", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable List<Long> ids) {
        return toAjax(bizDayworkItemService.removeBatchByIds(ids));
    }
   //修改周转信息
    @Transactional
    @PutMapping("/updateTurnoverInfo")
    public AjaxResult updateTurnoverInfo(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException,IllegalAccessException {
        //查到需要修改的周转信息
        BizDayworkItem dayworkItem = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId())
                .eq("process_step_number", bizDayworkItem.getProcessStepNumber())
                .eq("status", 4).list().get(0);
            //车间外周转
            dayworkItem.setDeptId(bizDayworkItem.getDeptId());
            dayworkItem.setDeptName(bizDayworkItem.getDeptName());
        bizDayworkItemService.updateById(dayworkItem);
        //修改daywork表信息
        BizDaywork daywork = bizDayworkService.query().eq("id", bizDayworkItem.getDayworkId()).list().get(0);
        daywork.setDeptId(dayworkItem.getDeptId());
        bizDayworkService.updateById(daywork);
        // 自动派活
        SysDept sysDept = sysDeptMapper.selectDeptById(dayworkItem.getDeptId());
        if (sysDept.getAutoAllocation() == 1) {
            // 查资源组
            List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

            //查询是否已经分配资源组
            BizProductionResourceGroupSubPlan groupSubPlan=new BizProductionResourceGroupSubPlan();
            groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
            groupSubPlan.setProductionPlanDetailId(daywork.getProductionPlanDetailId());

            List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
            //如果没分配
            if(groupSubPlanList.size()==0){
                //查产品id
                BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", daywork.getProductionPlanDetailId()));
                //存放保存的subPlanList
                List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                for (BizProductionResourceGroup info : productionResourceGroupList) {
                    BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                    subPlan.setProductId(productionPlanDetail.getProductId());
                    subPlan.setProductionPlanDetailId(daywork.getProductionPlanDetailId());
                    subPlan.setTechnologicalProcessId(daywork.getTechnologicalProcessId());
                    subPlan.setResourceGroupId(info.getId());
                    subPlan.setDeptId(bizDayworkItem.getDeptId());
                    subPlan.setResourceGroupCode(info.getCode());
                    subPlanList.add(subPlan);
                }
                bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
            }

        }

        return success();
}
    /***       外协周转。暂时注释       ***/
    @Log(title="外协周转申请")
    @Transactional
    @PostMapping("/turnoverOutsource")
    public AjaxResult turnoverOutsource(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException,IllegalAccessException {
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
        SysDept sysDept = sysDeptMapper.selectDeptByCode(bizDayworkItem.getDeptCode());
        bizDayworkItem.setDeptId(sysDept.getDeptId());
        bizDayworkItem.setDeptName(sysDept.getDeptName());
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("is_changed", 0).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
        // 关联批次的所有最后一条报工
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        for (BizDaywork v : bizDayworks) {
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                if (bizDayworkItem.getStatus().equals("7")||bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    v.setProcessQualifiedNum(v.getTemporaryProcessQualifiedNum());
                    bizDayworkService.updateById(v);
                }
                if(v.getIsAmend()==1){
                    bizItem.setFormDayworkItemId(1L);
                }
                bizItem.setProdNum(v.getTemporaryProcessQualifiedNum());
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(user.getUserId());
                bizItem.setUserName(user.getUserName());
                bizItem.setNickName(user.getNickName());
                bizItem.setWorkingHours(0L);
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);

            }
        }
        return success();
    }

    @Log(title="周转申请")
    @Transactional
    @PostMapping("/turnover")
    public AjaxResult turnover(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException,IllegalAccessException {
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
//        bizDayworkItem.getCarrierId();
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("is_changed", 0).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
        // 关联批次的所有最后一条报工
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        for (BizDaywork v : bizDayworks) {
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                if (bizDayworkItem.getStatus().equals("7")||bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    int sum = bizDayworkItems.stream()
                            .filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()))
                            .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                            .sum();
                    v.setTemporaryProcessQualifiedNum(sum);
                    bizDayworkService.updateById(v);
                }
                if(v.getIsAmend()==1){
                    bizItem.setFormDayworkItemId(1L);
                }
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(user.getUserId());
                bizItem.setUserName(user.getUserName());
                bizItem.setNickName(user.getNickName());
                bizItem.setWorkingHours(0L);
                bizItem.setDeptId(lastItem.getDeptId());
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);
                // 自动派活
                SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
                if (sysDept.getAutoAllocation() == 1) {
                    // 查资源组
                    List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

                    //查询是否已经分配资源组
                    BizProductionResourceGroupSubPlan groupSubPlan=new BizProductionResourceGroupSubPlan();
                    groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
                    groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());

                    List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
                    //如果没分配
                    if(groupSubPlanList.size()==0){
                        //查产品id
                        BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                        //存放保存的subPlanList
                        List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                        for (BizProductionResourceGroup info : productionResourceGroupList) {
                            BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                            subPlan.setProductId(productionPlanDetail.getProductId());
                            subPlan.setProductionPlanDetailId(v.getProductionPlanDetailId());
                            subPlan.setTechnologicalProcessId(v.getTechnologicalProcessId());
                            subPlan.setResourceGroupId(info.getId());
                            subPlan.setDeptId(bizDayworkItem.getDeptId());
                            subPlan.setResourceGroupCode(info.getCode());
                            subPlanList.add(subPlan);
                        }
                        bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
                    }

                }
            }
        }

        return toAjax(batch);
    }

}
