package cn.ezhizao.project.business.product.controller;

import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.project.business.inspection.domain.BizInspectionInstruction;
import cn.ezhizao.project.business.inspection.domain.BizProductInspectionInstruction;
import cn.ezhizao.project.business.inspection.service.IBizInspectionInstructionService;
import cn.ezhizao.project.business.inspection.service.IBizProductInspectionInstructionService;
import cn.ezhizao.project.business.product.domain.*;
import cn.ezhizao.project.business.product.service.*;
import cn.ezhizao.project.business.technologicalProcess.domain.BizTechnologicalProcess;
import cn.ezhizao.project.business.technologicalProcess.service.IBizTechnologicalProcessService;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import cn.ezhizao.project.system.domain.SysUser;
import cn.ezhizao.project.system.service.ISysUserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.management.Query;
import java.util.*;
import java.util.stream.Collectors;

// 分选报工controller
@RestController
@RequestMapping("/business/sortDaywork")
public class SortDayworkController extends BaseController {
    @Resource
    private IBizDayworkItemService bizDayworkItemService;
    @Resource
    private IBizInspectionInstructionService bizInspectionInstructionService;
    @Resource
    private IBizDayworkItemConsultService bizDayworkItemConsultService;
    @Resource
    private IBizProductInspectionInstructionService bizProductInspectionInstructionService;
    @Resource
    private IBizDayworkItemRejectService bizDayworkItemRejectService;
    @Resource
    private IBizProductService productService;
    @Resource
    private IBizProductionPlanDetailService productionPlanDetailService;
    @Resource
    private IBizLotService bizLotService;
    @Resource
    private IBizDayworkService bizDayworkService;
    @Resource
    private IBizLotTechnologicalProcessDetailService bizLotTechnologicalProcessDetailService;
    @Resource
    private IBizTechnologicalProcessDetailService bizTechnologicalProcessDetailService;
    @Resource
    private IBizDayworkCarrierService bizDayworkCarrierService;
    @Resource
    private IBizLotTechnologicalProcessService bizLotTechnologicalProcessService;
    @Resource
    private IBizTechnologicalProcessService bizTechnologicalProcessService;
    @Resource
    private ISysUserService sysUserService;
    // 修改报工状态为开始
    @PostMapping("/start")
    public AjaxResult start(@RequestBody BizDaywork bizDaywork) {
        // 获取最新报工
        List<BizDayworkItem> items = bizDayworkItemService.query().eq("daywork_id", bizDaywork.getId()).orderByDesc("create_time").lt("status", "4").list();
        BizDayworkItem item = items.get(0);
        if (item.getStatus().equals("0")) {
            item.setStatus("1");
            item.setStartTime(new Date());
            bizDayworkItemService.updateById(item);
        }
        BizDayworkItem conditions = new BizDayworkItem();
        conditions.setId(item.getId());
        List<BizDayworkItem> firstList = bizDayworkItemService.getList(conditions);
        item = firstList.isEmpty() ? item : firstList.get(0);
        List<BizDayworkItemReject> rejectList = bizDayworkItemRejectService.query().eq("daywork_item_id", item.getId()).list();
        item.setRejectList(rejectList);
        List<BizDayworkItemConsult> consults = bizDayworkItemConsultService.query().eq("daywork_item_id", item.getId()).list();
        item.setConsults(consults);
        BizProductionPlanDetail productionPlanDetail = productionPlanDetailService.getById(item.getProductionPlanDetailId());
        BizProduct product = productService.getById(productionPlanDetail.getProductId());
        SysUser user = sysUserService.selectUserById(product.getTechnicianId());
        item.setTechnicianName(user == null ? "" : user.getNickName());
        item.setTechnicianId(user == null ? 0L : user.getUserId());
        return success(item);
    }

    @PostMapping("/getInspectionList")
    public AjaxResult getInspectionList(@RequestBody BizDayworkItem bizDayworkItem) {
        Map<String, Object> map = new HashMap<>();
        //判断该报工是否是正常批次
        BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
        if(bizLot.getIsAmend() == 1 || bizLot.getIsWasteRecycling()==1) {
            //如果是废品回用或者是单批单改的批次，工艺id通过lot表的工艺版本和产品id找出来对应的工艺
            BizTechnologicalProcess bizTechnologicalProcess = bizTechnologicalProcessService.query().eq("technology_version", bizLot.getTechnologyVersion()).eq("product_id", bizLot.getProductId()).list().get(0);
            bizDayworkItem.setTechnologicalProcessId(bizTechnologicalProcess.getId());
        }
        // 查找所有该工序和产品对应的分选标准和检查指导书
        List<BizProductInspectionInstruction> list = bizProductInspectionInstructionService.query().eq("technological_process_id", bizDayworkItem.getTechnologicalProcessId()).eq("process_id", bizDayworkItem.getProcessId()).list();

        // 查询所有的分选标准
        List<BizInspectionInstruction> inspectionStandard = bizInspectionInstructionService.query().in("id", list.isEmpty() ? Collections.singletonList("0"): list.stream().map(BizProductInspectionInstruction::getInspectionInstructionId).collect(Collectors.toList())).eq("type", 1).list();
        // 查询所有的检查指导书
        List<BizInspectionInstruction> inspectionInstructions = bizInspectionInstructionService.query().in("id", list.isEmpty() ? Collections.singletonList("0"): list.stream().map(BizProductInspectionInstruction::getInspectionInstructionId).collect(Collectors.toList())).eq("type", 2).list();
        map.put("instructions", inspectionInstructions);
        map.put("standards", inspectionStandard);
        return success(map);
    }

    @PostMapping("saveConsult")
    public AjaxResult saveConsult(@RequestBody BizDayworkItemConsult bizDayworkItemConsult) {
        if (bizDayworkItemConsultService.save(bizDayworkItemConsult)){
            List<BizDayworkItemConsult> bizDayworkItemConsults = bizDayworkItemConsultService.query().eq("daywork_item_id", bizDayworkItemConsult.getDayworkItemId()).list();
            return success(bizDayworkItemConsults);
        } else {
            return error("咨询提交失败");
        }
    }

    @PostMapping("update")
    public AjaxResult update(@RequestBody BizDayworkItem bizDayworkItem) {
        BizDayworkItem item = bizDayworkItemService.getById(bizDayworkItem.getId());
        List<BizDayworkItemReject> rejectList = bizDayworkItem.getRejectList();
        BizDayworkItemReject delCondition = new BizDayworkItemReject();
        delCondition.setDayworkItemId(item.getId());
        bizDayworkItemRejectService.physicalDelete(delCondition);
        rejectList.forEach(l -> {
            l.setDayworkId(item.getDayworkId());
            l.setDayworkItemId(item.getId());
            l.setLotId(item.getLotId());
            l.setUserId(item.getUserId());
            l.setProductionPlanDetailId(item.getProductionPlanDetailId());
            l.setProductionPlanDetailSubDetailId(item.getProductionPlanDetailSubDetailId());
            l.setReason(l.getReason());
        });
        boolean result = rejectList.isEmpty() || bizDayworkItemRejectService.saveBatch(rejectList);
        item.setRejectNum(bizDayworkItem.getRejectNum());
        item.setRejectSum(bizDayworkItem.getRejectSum());
        item.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        item.setRemark(bizDayworkItem.getRemark());
        result = result && bizDayworkItemService.updateById(item);
        return result ? success() : error("保存失败");
    }

    @PostMapping("finish")
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult finish(@RequestBody BizDayworkItem bizDayworkItem) {
        BizDayworkItem item = bizDayworkItemService.getById(bizDayworkItem.getId());

        BizDayworkItemReject delCondition = new BizDayworkItemReject();
        delCondition.setDayworkItemId(item.getId());
        bizDayworkItemRejectService.physicalDelete(delCondition);
        List<BizDayworkItemReject> rejectList = bizDayworkItem.getRejectList();
        rejectList.forEach(l -> {
            l.setDayworkId(item.getDayworkId());
            l.setDayworkItemId(item.getId());
            l.setLotId(item.getLotId());
            l.setUserId(item.getUserId());
            l.setProductionPlanDetailId(item.getProductionPlanDetailId());
            l.setProductionPlanDetailSubDetailId(item.getProductionPlanDetailSubDetailId());
            l.setReason(l.getReason());
        });
        boolean result = rejectList.isEmpty() || bizDayworkItemRejectService.saveBatch(rejectList);
        item.setRejectNum(bizDayworkItem.getRejectNum());
        item.setRejectSum(bizDayworkItem.getRejectSum());
        item.setQualifiedNum(bizDayworkItem.getQualifiedNum());
        item.setRemark(bizDayworkItem.getRemark());
        bizDayworkItem.setStatus("3");
        bizDayworkItem.setEndTime(new Date());
        if(bizDayworkItem.getStartTime()==null){
            bizDayworkItem.setStartTime(new Date());
        }
        bizDayworkItem.setWorkingHours(bizDayworkItem.getEndTime().getTime() - bizDayworkItem.getStartTime().getTime());
        result = result && bizDayworkItemService.updateById(bizDayworkItem);
        BizDaywork bizDaywork = bizDayworkService.getById(item.getDayworkId());
        boolean returnCarrier;

        if (bizDaywork.getIsAmend().equals(1) || bizDaywork.getIsWasteRecycling().equals(1)) {
//            List<BizLotTechnologicalProcess> processes = bizLotTechnologicalProcessService.query().eq("lot_id", bizDaywork.getLotId()).list();
//            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", processes.stream().map(BizLotTechnologicalProcess::getId).collect(Collectors.toList())).list();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetails = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizLotTechnologicalProcessDetail()).getProcessStepNumber());
//                    item.getProcessStepNumber().equals(bizLotTechnologicalProcessDetails.stream().max(Comparator.comparing(BizLotTechnologicalProcessDetail::getProcessStepNumber)));
        } else {
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetails = bizTechnologicalProcessDetailService.query().ne("tenant_id", 9).eq("technological_process_id", item.getTechnologicalProcessId()).list();
//            returnCarrier = bizTechnologicalProcessDetails.stream().max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber().equals(item.getProcessStepNumber());
            returnCarrier = item.getProcessStepNumber().equals(bizTechnologicalProcessDetails.stream().filter(v -> !v.getTenantId().equals(9L)).max(Comparator.comparing(BizTechnologicalProcessDetail::getProcessStepNumber)).orElse(new BizTechnologicalProcessDetail()).getProcessStepNumber());
        }
        if (returnCarrier) {
            List<BizDayworkCarrier> bizDayworkCarriers = bizDayworkCarrierService.query().eq("daywork_id", item.getDayworkId()).eq("is_changed", 0).list();
            bizDayworkCarriers.forEach(l -> {
                l.setIsChanged(1);
            });
            result = result && (bizDayworkCarriers.isEmpty() || bizDayworkCarrierService.updateBatchById(bizDayworkCarriers));
        }
        return result ? success() : error("结束失败");
    }
}
