package cn.ezhizao.project.business.product.domain;


import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 废品原因对象 biz_daywork_item_reject
 *
 * @author ezhizao
 * @date 2023-12-28
 */
@Data
@TableName(value = "biz_daywork_item_reject")
public class BizDayworkItemReject extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** daywork的id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;

    /** 计划单id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanId;

    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;

    /** 子计划id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailId;

    /** 子计划工序对应的设备id？？？？？？？？？ */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailEquipmentId;

    /** 批次号 */
    @ApiModelProperty(value = "${comment}")
    private Long lotId;

    /** 报工明细id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkItemId;

    /** 废品原因 */
    @Excel(name = "废品原因")
    @ApiModelProperty(value = "废品原因")
    private String reason;

    @Excel(name = "序检 废品信息检查结果")
    @ApiModelProperty(value = "序检 废品信息检查结果")
    private String checkResult;

    @Excel(name = "检查标准")
    @ApiModelProperty(value = "检查标准")
    private String  checkStandard;

    @ApiModelProperty(value = "序检Id")
    private Long processInspectionId;

    /** 废品数 */
    @Excel(name = "废品数")
    @ApiModelProperty(value = "废品数")
    private Long rejectNum;

    @ApiModelProperty("检查指导书/分选标准")
    private Long inspectionInstructionId;

    @ApiModelProperty("类型")
    private Integer type;

}
