package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * 企业租户对象 biz_furnace_no_info
 *
 * @author ezhizao
 * @date 2024-01-30
 */
@Data
@TableName(value = "biz_furnace_no_info")
public class BizFurnaceNoInfo extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 生产计划单号 */
    @Excel(name = "生产计划单号")
    @ApiModelProperty(value = "生产计划单号")
    private String productionPlanNo;
    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;

    /** daywork的id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;
    /** 生产计划单序号 */
    @Excel(name = "生产计划单序号")
    @ApiModelProperty(value = "生产计划单序号")
    private String lineNumber;

    /** 厂家 */
    @Excel(name = "厂家")
    @ApiModelProperty(value = "厂家")
    private String factory;

    /** 炉号 */
    @Excel(name = "炉号")
    @ApiModelProperty(value = "炉号 ")
    private String furnaceNumber;

    /** 牌号 */
    @Excel(name = "牌号")
    @ApiModelProperty(value = "牌号")
    private String brandNumber;

    /** 规格 */
    @Excel(name = "规格")
    @ApiModelProperty(value = "规格")
    private String spec;

    /** 材料直径 */
    @Excel(name = "材料直径")
    @ApiModelProperty(value = "材料直径")
    private String diameter;

    /** 形状 */
    @Excel(name = "形状")
    @ApiModelProperty(value = "形状")
    private String shape;

    /** 技术要求1 */
    @Excel(name = "技术要求1")
    @ApiModelProperty(value = "技术要求1")
    private String firstTechnicalRequirement;

    /** 技术要求2 */
    @Excel(name = "技术要求2")
    @ApiModelProperty(value = "技术要求2")
    private String secondTechnicalRequirement;

    /** 原料编码 */
    @Excel(name = "原料编码")
    @ApiModelProperty(value = "原料编码")
    private String rawMaterialCode;

    /** 来料日期 */
    @Excel(name = "来料日期")
    @ApiModelProperty(value = "来料日期")
    private String incomingDate;

}
