package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


/**
 * 修改后工艺对象 biz_technological_amend
 *
 * @author ezhizao
 * @date 2024-04-07
 */
@Data
@TableName(value = "biz_lot_technological_process")
public class BizLotTechnologicalProcess extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 批次id */
    @ApiModelProperty(value = "批次id")
    private Long lotId;


    /** 轴类型 */
    @Excel(name = "轴类型")
    @ApiModelProperty(value = "轴类型")
    private String productShaftCategoryName;

    /** 产品编码 */
    @Excel(name = "产品编码")
    @ApiModelProperty(value = "产品编码")
    private String productCode;

    /** 规格 */
    @Excel(name = "规格")
    @ApiModelProperty(value = "规格")
    private String productSpecification;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @ApiModelProperty(value = "产品描述")
    private String productDescription;


    /** 图号 */
    @Excel(name = "图号")
    @ApiModelProperty(value = "图号")
    private String productDrawingNumber;

    /** 轴类型码 */
    @Excel(name = "轴类型码")
    @ApiModelProperty(value = "轴类型码")
    private String productShaftCategory;


    /** 批次号 */
    @Excel(name = "批次号")
    @ApiModelProperty(value = "批次号")
    private String lotCode;

    /** 计划单id */
    @ApiModelProperty(value = "计划单id")
    private Long productionPlanId;

    /** 计划单明细id */
    @ApiModelProperty(value = "计划单明细id")
    private Long productionPlanDetailId;

    /** 原始工艺id */
    @ApiModelProperty(value = "原始工艺id")
    private Long technologicalProcessId;

    /** 原始工艺版本A,B,C */
    @Excel(name = "原始工艺版本A,B,C")
    @ApiModelProperty(value = "原始工艺版本A,B,C")
    private String technologyVersion;

    /** 产品id */
    @ApiModelProperty(value = "产品id")
    private Long productId;

    /** 是否停用(0 否，1 是) */
    @Excel(name = "是否停用(0 否，1 是)")
    @ApiModelProperty(value = "是否停用(0 否，1 是)")
    private Integer isStop;

    @Excel(name = "修改版本(第几次修改此批工艺)")
    @ApiModelProperty(value = "修改版本(第几次修改此批工艺)")
    private Integer amendmentVersions;

}
