package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 工艺修改明细对象 biz_technological_amend_detail
 *
 * @author ezhizao
 * @date 2024-04-07
 */
@Data
@TableName(value = "biz_lot_technological_process_detail")
public class BizLotTechnologicalProcessDetail extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 工艺id */
    @ApiModelProperty(value = "${comment}")
    private Long lotTechnologicalProcessId;

    @ApiModelProperty(value = "批次")
    private Long lotId;

    /** 工艺编码 */
    @Excel(name = "工艺编码")
    @ApiModelProperty(value = "工艺编码")
    private String technologyVersion;

    /** 产品id */
    @ApiModelProperty(value = "产品id")
    private Long productId;

    /** 产品编码 */
    @Excel(name = "产品编码")
    @ApiModelProperty(value = "产品编码")
    private String productCode;

    /** 工序排序*/
    @Excel(name = "工序排序")
    @ApiModelProperty(value = "工序排序 ")
    private String processStepNumber;

    /** 工序id */
    @ApiModelProperty(value = "工序id ")
    private Long processId;

    /** 工序key值 */
    @Excel(name = "工序key值")
    @ApiModelProperty(value = "工序key值")
    private String processKey;

    /** 工序编码 */
    @Excel(name = "工序编码")
    @ApiModelProperty(value = "工序编码")
    private String processCode;

    /** 工序简称 */
    @Excel(name = "工序简称")
    @ApiModelProperty(value = "工序简称")
    private String processAlias;

    /** 轴类型码 */
    @Excel(name = "轴类型码")
    @ApiModelProperty(value = "轴类型码")
    private String productShaftCategory;

    /** 轴类型助记码EPS */
    @Excel(name = "轴类型助记码EPS")
    @ApiModelProperty(value = "轴类型助记码EPS")
    private String productShaftCategoryName;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @ApiModelProperty(value = "产品描述")
    private String productDescription;

}
