package cn.ezhizao.project.business.product.service;


import cn.ezhizao.project.business.product.domain.BizProductionPlanDetailSubDetail;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * 生产子计划明细Service接口
 *
 * @author ezhizao
 * @date 2023-11-15
 */
public interface IBizProductionPlanDetailSubDetailService extends IService<BizProductionPlanDetailSubDetail> {
    /**
     * 查询生产子计划明细列表
     *
     * @param bizProductionPlanDetailSubDetail 生产子计划明细
     * @return 生产子计划明细集合
     */
    List<BizProductionPlanDetailSubDetail> getList(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail);

    /**
     * 物理删除
     * @param bizProductionPlanDetailSubDetail 实体
     * @return 删除结果
     */
    int physicalDelete(BizProductionPlanDetailSubDetail bizProductionPlanDetailSubDetail);

    /**
     * 根据关键字查询
     * @param keywords 关键字
     * @return List<BizProductionPlanDetailSubDetail> 列表
     */
    List<BizProductionPlanDetailSubDetail> getListByKeywords(String keywords);

    /**
     * 根据人员绑定的设备查询生产子计划明细列表
     *
     * @param  生产子计划明细
     * @return 生产子计划明细集合
     */
    List<BizProductionPlanDetailSubDetail> getListByUserEquipment(Map<String, Object> data);
}
