package cn.ezhizao.project.business.product.service.impl;

import cn.ezhizao.project.business.product.domain.BizDayworkItemConsult;
import cn.ezhizao.project.business.product.mapper.BizDayworkItemConsultMapper;
import cn.ezhizao.project.business.product.service.IBizDayworkItemConsultService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 检查指导书Service业务层处理
 *
 * @author zhuangdezheng
 * date    2024-04-23
 */
@Service
public class BizDayworkItemConsultServiceImpl extends ServiceImpl<BizDayworkItemConsultMapper, BizDayworkItemConsult> implements IBizDayworkItemConsultService {
    @Resource
    private BizDayworkItemConsultMapper bizDayworkItemConsultMapper;

    /**
     * 查询检测指导书列表
     *
     * @param data 查询条件
     * @return 检测指导书集合
     */
    @Override
    public List<BizDayworkItemConsult> getList(Map<String, Object> data)
    {
        return bizDayworkItemConsultMapper.getList(data);
    }

    /**
     * 物理删除
     *
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkItemConsult bizDayworkItemConsult) {
        return bizDayworkItemConsultMapper.physicalDelete(bizDayworkItemConsult);
    }
}
