package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizFurnaceNoInfo;
import cn.ezhizao.project.business.product.mapper.BizFurnaceNoInfoMapper;
import cn.ezhizao.project.business.product.service.IBizFurnaceNoInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 企业租户Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-30
 */
@Service
public class BizFurnaceNoInfoServiceImpl  extends ServiceImpl<BizFurnaceNoInfoMapper, BizFurnaceNoInfo> implements IBizFurnaceNoInfoService
{
    @Resource
    private BizFurnaceNoInfoMapper bizFurnaceNoInfoMapper;

    /**
     * 查询企业租户列表
     *
     * @param bizFurnaceNoInfo 企业租户
     * @return 企业租户
     */
    @Override
    public List<BizFurnaceNoInfo> getList(BizFurnaceNoInfo bizFurnaceNoInfo)
    {
        return bizFurnaceNoInfoMapper.getList(bizFurnaceNoInfo);
    }

    /**
     * 物理删除
     * @param bizFurnaceNoInfo
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizFurnaceNoInfo bizFurnaceNoInfo){ return bizFurnaceNoInfoMapper.physicalDelete(bizFurnaceNoInfo); };

}
