package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizLot;
import cn.ezhizao.project.business.product.mapper.BizLotMapper;
import cn.ezhizao.project.business.product.service.IBizLotService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * 批次号Service业务层处理
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@Service
public class BizLotServiceImpl  extends ServiceImpl<BizLotMapper, BizLot> implements IBizLotService
{
    @Resource
    private BizLotMapper bizLotMapper;

    /**
     * 查询批次号列表
     *
     * @param bizLot 批次号
     * @return 批次号
     */
    @Override
    public List<BizLot> getList(BizLot bizLot)
    {
        return bizLotMapper.getList(bizLot);
    }
    /**
     * 获取废品回收批次号
     * @param bizLot
     * @return
     */
    @Override
    public List<BizLot> getWasteRecyclingLot(BizLot bizLot) {
        return bizLotMapper.getWasteRecyclingLot(bizLot);
    }

    /**
     * 物理删除
     * @param bizLot
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizLot bizLot){ return bizLotMapper.physicalDelete(bizLot); }

    @Override
    public List<BizLot> getAllList(BizLot lot) {
        return bizLotMapper.getAllList(lot);
    }

}
