package cn.ezhizao.project.business.product.service.impl;

import cn.ezhizao.project.business.product.domain.BizProductionPlanDetail;
import cn.ezhizao.project.business.product.mapper.BizProductionPlanDetailMapper;
import cn.ezhizao.project.business.product.service.IBizProductionPlanDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 生产计划明细Service业务层处理
 *
 * @author ruoyi
 * @date 2023-11-04
 */
@Service
public class BizProductionPlanDetailServiceImpl  extends ServiceImpl<BizProductionPlanDetailMapper, BizProductionPlanDetail> implements IBizProductionPlanDetailService
{
    @Resource
    private BizProductionPlanDetailMapper bizProductionPlanDetailMapper;

    /**
     * 查询生产计划明细列表
     *
     * @param data 生产计划明细
     * @return 生产计划明细
     */
    @Override
    public List<BizProductionPlanDetail> getList(Map<String, Object> data)
    {
        return bizProductionPlanDetailMapper.getList(data);
    }
    /**
     * 根据生产计划明细查询生产计划明细
     * @param bizProductionPlanDetail 生产计划明细
     * @return 生产计划明细
     */

    @Override
    public List<BizProductionPlanDetail> getInfo(BizProductionPlanDetail bizProductionPlanDetail)
    {
        return  bizProductionPlanDetailMapper.getInfo(bizProductionPlanDetail);
    }




    /**
     * 物理删除
     * @param bizProductionPlanDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProductionPlanDetail bizProductionPlanDetail){ return bizProductionPlanDetailMapper.physicalDelete(bizProductionPlanDetail); };

}
