package cn.ezhizao.project.business.product.service.impl;

import cn.ezhizao.project.business.product.domain.BizDaywork;
import cn.ezhizao.project.business.product.domain.BizReturnReceiptDetail;
import cn.ezhizao.project.business.product.mapper.BizReturnReceiptDetailMapper;
import cn.ezhizao.project.business.product.service.IBizReturnReceiptDetailService;
import cn.ezhizao.project.system.domain.SysDept;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 外协单从Service业务层处理
 *
 * @author ezhizao
 * @date 2024-05-08
 */
@Service
public class BizReturnReceiptDetailServiceImpl  extends ServiceImpl<BizReturnReceiptDetailMapper, BizReturnReceiptDetail> implements IBizReturnReceiptDetailService
{
    @Resource
    private BizReturnReceiptDetailMapper bizReturnReceiptDetailMapper;

    /**
     * 查询外协单从列表
     *
     * @param bizReturnReceiptDetail 外协单从
     * @return 外协单从
     */
    @Override
    public List<BizReturnReceiptDetail> getList(BizReturnReceiptDetail bizReturnReceiptDetail)
    {
        return bizReturnReceiptDetailMapper.getList(bizReturnReceiptDetail);
    }
    @Override
    public List<BizReturnReceiptDetail> getFinishedReturnList(BizReturnReceiptDetail bizReturnReceiptDetail) {
        return bizReturnReceiptDetailMapper.getFinishedReturnList(bizReturnReceiptDetail);
    }

    @Override
    public List<SysDept> getTurnoverAbDeptList(BizDaywork bizDaywork) {
        return bizReturnReceiptDetailMapper.getTurnoverAbDeptList(bizDaywork);
    }

    @Override
    public List<SysDept> getTurnoverDeptList(BizDaywork bizDaywork) {
        return bizReturnReceiptDetailMapper.getTurnoverDeptList(bizDaywork);
    }

    /**
     * 物理删除
     * @param bizReturnReceiptDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizReturnReceiptDetail bizReturnReceiptDetail){ return bizReturnReceiptDetailMapper.physicalDelete(bizReturnReceiptDetail); };

}
