package cn.ezhizao.project.business.resourceGroup.mapper;



import cn.ezhizao.project.business.product.domain.BizDaywork;
import cn.ezhizao.project.business.product.domain.BizDayworkItem;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupDetail;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;


/**
 * 工段资源组明细Mapper接口
 *
 * @author ezhizao
 * @date 2024-01-10
 */
public interface BizProductionResourceGroupDetailMapper extends BaseMapper<BizProductionResourceGroupDetail>
{
    /**
     * 查询工段资源组明细列表
     *
     * @param bizProductionResourceGroupDetail 工段资源组明细
     * @return 工段资源组明细集合
     */
    public List<BizProductionResourceGroupDetail> getList(BizProductionResourceGroupDetail bizProductionResourceGroupDetail);

    /**
     * 物理删除
     * @param bizProductionResourceGroupDetail
     * @return 删除结果
    */

    public int physicalDelete(BizProductionResourceGroupDetail bizProductionResourceGroupDetail);

    /**
     * 查询资源组设备
     * @param userId
     * @param deptId
     * @return
     */
    public List<BizProductionResourceGroupDetail> getEquipmentByUidAndDid(Long userId,Long deptId);
    /**
     * 删除临时人员
     * @param bizDayworkItem
     */

    public void deleResourceGroupDetailPeople(List<Long> detailIds);
}
