package cn.ezhizao.project.business.shaftCategory.domain;


import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 盘点同步对象 biz_shaft_category
 *
 * @author ezhizao
 * @date 2023-11-15
 */
@Data
@TableName(value = "biz_shaft_category")
public class BizShaftCategory extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 类别 */
    @Excel(name = "类别")
    @ApiModelProperty(value = "类别")
    private String type;

    /** 大类码 */
    @Excel(name = "大类码")
    @ApiModelProperty(value = "大类码")
    private String majorCategoryCode;

    /** 小类码 */
    @Excel(name = "小类码")
    @ApiModelProperty(value = "小类码")
    private String subCategoryCode;

    /** 大类描述 */
    @Excel(name = "大类描述")
    @ApiModelProperty(value = "大类描述")
    private String description;

    /** 最大序号 */
    @Excel(name = "最大序号")
    @ApiModelProperty(value = "最大序号")
    private Integer num;

    /** 小类助记码 */
    @Excel(name = "小类助记码")
    @ApiModelProperty(value = "小类助记码")
    private String subCategoryFindKey;

    /** 简称 */
    @Excel(name = "简称")
    @ApiModelProperty(value = "简称")
    private String descriptionShort;

}
