package cn.ezhizao.project.business.technologicalProcessDetail.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.mapper.BizTechnologicalProcessDetailMapper;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 工艺工序中间表Service业务层处理
 *
 * @author ezhizao
 * @date 2023-11-16
 */
@Service
public class BizTechnologicalProcessDetailServiceImpl  extends ServiceImpl<BizTechnologicalProcessDetailMapper, BizTechnologicalProcessDetail> implements IBizTechnologicalProcessDetailService
{
    @Resource
    private BizTechnologicalProcessDetailMapper bizTechnologicalProcessDetailMapper;

    /**
     * 查询工艺工序中间表列表
     *
     * @param bizTechnologicalProcessDetail 工艺工序中间表
     * @return 工艺工序中间表
     */
    @Override
    public List<BizTechnologicalProcessDetail> getList(BizTechnologicalProcessDetail bizTechnologicalProcessDetail)
    {
        return bizTechnologicalProcessDetailMapper.getList(bizTechnologicalProcessDetail);
    }

    /**
     * 物理删除
     * @param bizTechnologicalProcessDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTechnologicalProcessDetail bizTechnologicalProcessDetail){ return bizTechnologicalProcessDetailMapper.physicalDelete(bizTechnologicalProcessDetail); };

}
