package cn.ezhizao.project.business.workshop.controller;

import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.project.business.turnover.domain.BizTurnover;
import cn.ezhizao.project.business.workshop.domain.BizWorkshopTurnover;
import cn.ezhizao.project.business.workshop.service.IBizWorkshopTurnoverService;
import cn.ezhizao.project.system.domain.SysDept;
import cn.ezhizao.project.system.mapper.SysDeptMapper;
import cn.ezhizao.project.system.service.ISysDeptService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;


/**
 * 周转区Controller
 *
 * @author zhuangdezheng
 * @date 2024-04-20
 */
@RestController
@RequestMapping("/business/workshop")
public class BizWorkshopController extends BaseController {
    @Resource
    private ISysDeptService iSysDeptService;

    @Resource
    private IBizWorkshopTurnoverService iBizWorkshopTurnoverService;
    @Resource
    private SysDeptMapper sysDeptMapper;

    /**
     * 查询周转区列表
     */
//    @PreAuthorize("@ss.hasPermi('business:workshop:turnover')")
    @Log(title = "周转区列表获取", businessType = BusinessType.SELECT)
    @PostMapping("/turnover")
    public AjaxResult turnover(@RequestBody Map<String, Object> data) throws NoSuchFieldException, IllegalAccessException {
        long deptId = Long.parseLong(data.get("deptId").toString());
        SysDept dept = iSysDeptService.selectDeptById(deptId);
        List<BizWorkshopTurnover> workshopTurnovers = iBizWorkshopTurnoverService.query()
                .eq("workshop_id", dept.getWorkshopId())
                .eq("status",0)
                .list();

        return success(workshopTurnovers);
    }
    @PostMapping("/outsourceTurnover")
    public AjaxResult outsourceTurnover(@RequestBody Map<String, Object> data) throws NoSuchFieldException, IllegalAccessException {
        String deptCode = (data.get("deptCode").toString());
        SysDept sysDept = sysDeptMapper.selectDeptByCode(deptCode);
        List<BizWorkshopTurnover> workshopTurnovers = iBizWorkshopTurnoverService.query()
                .eq("workshop_id", sysDept.getWorkshopId())
                .eq("status",0)
                .list();

        return success(workshopTurnovers);
    }
}
