package cn.ezhizao.project.system.domain;

import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.ArrayList;
import java.util.List;

/**
 * 部门表 sys_dept
 *
 * @author ruoyi
 */
@Data
public class SysDept extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 部门ID
     */
    private Long deptId;

    @TableField(exist = false)
    private Long tenantId;
    /**
     * 父部门ID
     */
    private Long parentId;

    /**
     * 祖级列表
     */
    private String ancestors;


    /**
     * 部门名称
     */
    private String deptName;

    /**
     * 统一社会信用编码
     */
    private String deptCode;

    /**
     * 显示顺序
     */
    private Integer orderNum;


    /**
     * 联系电话
     */
    private String phone;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 部门状态:0正常,1停用
     */
    private String status;

    /**
     * 删除标志（0代表存在 2代表删除）
     */
    private String delFlag;

    /**
     * 父部门名称
     */
    private String parentName;

    /**
     * 角色名称
     */
    private String role;

    /**
     * 是否为企业
     */
    private String type;

    @TableField(exist = false)
    private Long id;

    /**
     * 是否为工段（0：否，1：是）默认0
     */
    private Integer isWorkSection;

    @TableField(exist = false)
    private Long productionPlanDetailId;

    @TableField(exist = false)
    private Integer isAmend;

    @TableField(exist = false)
    private Long lotId;
    @TableField(exist = false)
    private Integer isWasteRecycling;

    @TableField(exist = false)
    private Long lotTechnologicalProcessId;

    public Long getLotTechnologicalProcessId() {
        return lotTechnologicalProcessId;
    }

    public void setLotTechnologicalProcessId(Long lotTechnologicalProcessId) {
        this.lotTechnologicalProcessId = lotTechnologicalProcessId;
    }

    public Long getLotId() {
        return lotId;
    }

    public void setLotId(Long lotId) {
        this.lotId = lotId;
    }

    public Integer getIsWasteRecycling() {
        return isWasteRecycling;
    }

    public void setIsWasteRecycling(Integer isWasteRecycling) {
        this.isWasteRecycling = isWasteRecycling;
    }

    // 是否自动派活
    private Integer autoAllocation;

    // 是否一机多批
    private Integer equimentFlag;

    // 开始报工前是否自动解绑
    private Integer autoUnbind;

    public List<Long> getDeptIds() {
        return deptIds;
    }

    public void setDeptIds(List<Long> deptIds) {
        this.deptIds = deptIds;
    }

    public Integer getHasQuick() {
        return hasQuick;
    }

    public void setHasQuick(Integer hasQuick) {
        this.hasQuick = hasQuick;
    }

    // 是否可以快速报工
    private Integer hasQuick;


    public Integer getAutoUnbind() {
        return autoUnbind;
    }

    public void setAutoUnbind(Integer autoUnbind) {
        this.autoUnbind = autoUnbind;
    }

    public Integer getAutoAllocation() {
        return autoAllocation;
    }

    public void setAutoAllocation(Integer autoAllocation) {
        this.autoAllocation = autoAllocation;
    }

    public Integer getEquimentFlag() {
        return equimentFlag;
    }

    public void setEquimentFlag(Integer equimentFlag) {
        this.equimentFlag = equimentFlag;
    }

    public Long getWorkshopId() {
        return workshopId;
    }

    public void setWorkshopId(Long workshopId) {
        this.workshopId = workshopId;
    }

    private Long workshopId;

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public Long getProductionPlanDetailId() {
        return productionPlanDetailId;
    }

    public void setProductionPlanDetailId(Long productionPlanDetailId) {
        this.productionPlanDetailId = productionPlanDetailId;
    }

    public Integer getIsWorkSection() {
        return isWorkSection;
    }
    public void setIsWorkSection(Integer isWorkSection) {
        this.isWorkSection = isWorkSection;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }


    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    /**
     * 子部门
     */
    private List<SysDept> children = new ArrayList<SysDept>();

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    public String getAncestors() {
        return ancestors;
    }

    public void setAncestors(String ancestors) {
        this.ancestors = ancestors;
    }

    @NotBlank(message = "部门名称不能为空")
    @Size(min = 0, max = 30, message = "部门名称长度不能超过30个字符")
    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    @NotNull(message = "显示顺序不能为空")
    public Integer getOrderNum() {
        return orderNum;
    }

    public void setOrderNum(Integer orderNum) {
        this.orderNum = orderNum;
    }


    @Size(min = 0, max = 11, message = "联系电话长度不能超过11个字符")
    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    @Email(message = "邮箱格式不正确")
    @Size(min = 0, max = 50, message = "邮箱长度不能超过50个字符")
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public List<SysDept> getChildren() {
        return children;
    }

    public void setChildren(List<SysDept> children) {
        this.children = children;
    }

    public String getDeptCode() {
        return deptCode;
    }

    public void setDeptCode(String deptCode) {
        this.deptCode = deptCode;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("deptId", getDeptId())
                .append("parentId", getParentId())
                .append("tenantId", getTenantId())
                .append("ancestors", getAncestors())
                .append("deptName", getDeptName())
                .append("orderNum", getOrderNum())
                .append("phone", getPhone())
                .append("email", getEmail())
                .append("status", getStatus())
                .append("delFlag", getDelFlag())
                .append("createBy", getCreateBy())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateTime", getUpdateTime())
                .toString();
    }

    @TableField(exist = false)
    private List<Long> deptIds;
}
