package cn.ezhizao.project.system.domain;

import cn.ezhizao.common.xss.Xss;
import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.aspectj.lang.annotation.Excel.ColumnType;
import cn.ezhizao.framework.aspectj.lang.annotation.Excel.Type;
import cn.ezhizao.framework.aspectj.lang.annotation.Excels;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 用户对象 sys_user
 *
 * @author ruoyi
 */
@Data
public class SysDeptUser extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 用户ID
     */
    @Excel(name = "用户序号", cellType = ColumnType.NUMERIC, prompt = "用户编号")
    private Long userId;

    private Long tenantId;

    /**
     * 部门ID
     */
    private Long deptId;


    /**
     * 是否主管
     * */
    private Boolean isLeader;

    /**
     * 是否兼职
     * */
    private Boolean isPartTime;


    /**
     * 是否调度
     * */
    private Boolean isDispatcher;

    /**
     * 是否工段长
     * */
    private Integer isFormman;

    /**
     * 是否调机
     * */
    private Integer isYardman;

    private Integer deleted;
    /**
     * 人员信息
     */
    @TableField(exist = false)
    private SysUser user;

    @TableField(exist = false)
    private String nickName ;
    @TableField(exist = false)
    private String deptName ;
    private Long isTemporary;
    /**
     * 部门信息
     */
    @TableField(exist = false)
    private SysDept dept;

}
