package cn.ezhizao.project.tenant.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 用户和租户的中间表对象 biz_user_tenant
 *
 * @author zhushan
 * @date 2023-08-17
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "biz_user_tenant")
public class BizUserTenant extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 用户id
     */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    @ApiModelProperty(value = "${comment}")
    private Long deptId;

    /**
     * 用户 是否 为 租户的创建者
     */
    @Excel(name = "用户 是否 为 租户的创建者")
    @ApiModelProperty(value = "用户 是否 为 租户的创建者")
    private Boolean isAdmin;

    /**
     * 状态
     */
    @Excel(name = "状态")
    @ApiModelProperty(value = "状态")
    private Integer status;

    @TableField(exist = false)
    private String orgName;
    @TableField(exist = false)
    private String orgNature;
    @TableField(exist = false)
    private String orgCrtCode;
    @TableField(exist = false)
    private String legalName;
    @TableField(exist = false)
    private String entPrefix;
    @TableField(exist = false)
    private String province;
    @TableField(exist = false)
    private String city;
    @TableField(exist = false)
    private String county;
    @TableField(exist = false)
    private String orgAddr;

}
